VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Cls_Convertion"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Declare local variable
Private CN_source                    As ADODB.Connection
Private MyCN                         As CLS_MySQL

Private sMySQLTableType              As String

' added 2004-11-02 {to respon cancel event}
Public EndProgress                   As Boolean

' Public event
Public Event Progress(ProgressStatus As Long)
Public Event ExecuteInfo(StrSQL As String)
Private rstIdx                      As ADODB.Recordset


'*********************************************************************
' Created date: 2004-10-29 09:56
' Purpose: Convert Access Table to MySQL Table
'*********************************************************************
Public Sub ConvTable(ByVal sTableName As String, _
    Optional WithData As Boolean = False, _
    Optional DropTable As Boolean = True, _
    Optional DumpSQLonly As Boolean = False)
    On Error Resume Next
    
    ' declare variable
    Dim Rst As New ADODB.Recordset
    
    Dim I As Long
    Dim j As Long
    Dim StrTemp As String
    Dim StrAccess As String
    Dim StrMySQL  As String
    Dim X As Long
    Dim Y As Long
    Dim pStt As Long
    Dim lPost As Long
    
    ' create SQL statement to open access table
    StrAccess = "select * from [" & sTableName & "] where " & WithData
    
    
    ' set cursor location
    Rst.CursorLocation = adUseClient
    ' open recordset
    Rst.Open StrAccess, CN_source, adOpenStatic, adLockOptimistic
    StrTemp = CreateTableByRecordset(sTableName, Rst, rstIdx, , True)
  
    
    ' check drop table
    If DropTable Then
        StrMySQL = "Drop table if exists `" & LCase(sTableName) & "`;"
        If DumpSQLonly = False Then
            ExecuteSQL StrMySQL
        End If
        RaiseEvent ExecuteInfo(StrMySQL)
        DoEvents
    End If
    
    If DumpSQLonly = False Then
    ' Execute SQL (DDL) "Create Table into MySQL Database"
        ExecuteSQL StrTemp
    End If
    
    RaiseEvent ExecuteInfo(StrTemp)
    DoEvents
    
    Call CreateIndexFromRst(MyCN, sTableName, rstIdx, True)
    
    
    'check with insert statement or not (include data or not)
    If WithData Then
        
        ' check recordset
        If Not (Rst.EOF And Rst.BOF) Then ' make sure recordset not empty
            'Generate Insert Statement (SQL:>DML)
            Y = Rst.RecordCount
            X = 0
            Do While ((Not Rst.EOF) And (Not EndProgress))
            
                ' get SQL insert statement
                StrMySQL = CreateInsertStmt(Rst, LCase(sTableName), True)
                If DumpSQLonly = False Then
                    ' execute SQL (DML)
                    ExecuteSQL StrMySQL
                End If
                
               
                RaiseEvent ExecuteInfo(StrMySQL)
                
                ' calculate progress (in percantage)
                X = X + 1
                pStt = (X / Y) * 100
                
                If lPost <> pStt Then
                    lPost = pStt
                    ' return progress
                    RaiseEvent Progress(lPost)
                End If
                
                ' recordset move
                Rst.MoveNext
                
                ' enable for cancel method
                DoEvents
                
            Loop
            
        End If
        
    End If
    
    If DumpSQLonly = False Then
        ' flush table
        ExecuteSQL "FLUSH TABLES"
    End If
    
    ' clean up
    StrTemp = vbNullString
    StrAccess = vbNullString
    Rst.Close
    Set Rst = Nothing

End Sub

'************************************************************************
' Created date: 2004-10-29 11:03
' Purpose: Open MS Access Database (Source)
'************************************************************************
Public Function OpenSourceDB(ByVal sFileName As String, Optional pwd As String) As Boolean
On Error Resume Next
On Error GoTo err_exit_access
    ' check connection status {Close ite if is opened}
    If CN_source.State Then
        CN_source.Close
    End If
    
    ' Try to open database
    If pwd <> vbNullString Then
        CN_source.Open "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & sFileName & ";Persist Security Info=False;Jet OLEDB:Database Password=" & pwd
    Else
        CN_source.Open "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & sFileName
    End If
    
    If CN_source.State Then
        Set rstIdx = CN_source.OpenSchema(adSchemaIndexes)
    End If

    ' return connection state
    OpenSourceDB = CN_source.State
Exit Function
err_exit_access:
    MsgBoxXP Err.Description, vbCritical, App.Title, , MyScheme
End Function

'************************************************************************
' Created date: 2004-10-29 11:12
' Purpose: Open Destination Database (MySQL database)
'************************************************************************
Public Function OpenDestinationDB(Optional host As String = "localhost", _
       Optional user As String = "root", Optional pwd As String, Optional port As Long = 3306) As Boolean
  ' declare local variable
  On Error GoTo err_exit_mycnconn
    
    MyCN.OpenConnection host, user, pwd, port
    
    
    ' try to open database and return connection state
    OpenDestinationDB = MyCN.State
    
    
    
Exit Function
err_exit_mycnconn:
    MsgBoxXP Err.Description, vbCritical, App.Title, , MyScheme
    
End Function

'***********************************************************************
' Created date: 2004-10-29 11:21
' Purpose: Use Mysql Database (SelectDB)
'***********************************************************************.
Public Sub SelectDB(sDBName As String)

    ' using 'USE' statement
    MyCN.Execute "USE `" & sDBName & "`;"
    DoEvents
    
End Sub

'***********************************************************************
' Created date: 2004-10-29 11:23
' Purpose: Create Database on MySQL server
'***********************************************************************
Public Sub createDB(sDBName As String)

    ' create database
    MyCN.Execute "create database if not exists `" & sDBName & "`;"
    ' Use these database
    SelectDB sDBName
    DoEvents
    
End Sub

'***********************************************************************
' Created date: 2004-10-29 12:32
' Purpose: Change default table type (Destination table type)
'***********************************************************************
Public Sub SetTableType(isType As String)
    
    sMySQLTableType = "TYPE=" & isType

End Sub

'***********************************************************************
' Created date: 2004-10-29 12:35
' Purpose: Return connection of source database (ADODB.Connection)
'***********************************************************************
Public Function SourceDB() As ADODB.Connection
    
    Set SourceDB = CN_source

End Function

'************************************************************************
' Created date: 2004-10-29 12:37
' Purpose: Return connection of Destination Database
'************************************************************************
Public Function DestinationDB() As ADODB.Connection
    
    Set DestinationDB = MyCN

End Function

'************************************************************************
' Created date: 2004-10-29 13:07
' Purpose: return mysql data format (yyyy-mm-dd)
'************************************************************************
Private Function MySQLDate(isdate As Date) As String
    
    MySQLDate = Format(isdate, "yyyy") & "-" & Format(isdate, "mm") & "-" & Format(isdate, "dd")

End Function

'*************************************************************************
' Created date: 2004-10-30 16:23
' Purpose: Execute SQL Scripts
'*************************************************************************
Public Sub ExecuteSQL(SQL As String)
    On Error Resume Next
    MyCN.Execute SQL
End Sub

'************************************************************************
' Class Methode
'************************************************************************
Private Sub Class_Initialize()

    ' initialize
    sMySQLTableType = "TYPE=MyISAM"
    Set CN_source = New ADODB.Connection
    Set MyCN = New CLS_MySQL
    
End Sub

Private Sub Class_Terminate()
    
    ' Clean up
    If CN_source.State Then
        CN_source.Close
    End If
    Set CN_source = Nothing
    
    If MyCN.State Then
        MyCN.CloseConnection
    End If
    Set MyCN = Nothing
    
End Sub
